import { CommonError, ICancellationToken, Result } from "@microsoft/powerquery-parser";
import { Position } from "vscode-languageserver-types";
import { Autocomplete, TActiveNode, TriedCurrentInvokeExpression, TriedNodeScope, TriedScopeType } from "../inspection";
import { AnalysisBase } from "./analysisBase";
export declare class MemoizedAnalysis extends AnalysisBase {
    private readonly activeNodeCache;
    private readonly autocompleteCache;
    private readonly currentInvokeExpressionCache;
    private readonly nodeScopeCache;
    private readonly scopeTypeCache;
    dispose(): void;
    getActiveNode(position: Position): Promise<Result<TActiveNode | undefined, CommonError.CommonError>>;
    protected inspectAutocomplete(activeNode: TActiveNode, correlationId: number, cancellationToken?: ICancellationToken): Promise<Autocomplete | undefined>;
    protected inspectCurrentInvokeExpression(position: Position, correlationId: number, cancellationToken?: ICancellationToken): Promise<TriedCurrentInvokeExpression | undefined>;
    protected inspectNodeScope(activeNode: TActiveNode, correlationId: number, cancellationToken?: ICancellationToken): Promise<TriedNodeScope | undefined>;
    protected inspectScopeType(activeNode: TActiveNode, correlationId: number, cancellationToken?: ICancellationToken): Promise<TriedScopeType | undefined>;
    private getOrCreate;
}
