import { Type } from "@microsoft/powerquery-parser/lib/powerquery-parser/language";
export declare type TExternalTypeRequest = ExternalValueTypeRequest | ExternalInvocationTypeRequest;
export declare type TExternalTypeResolverFn = (request: TExternalTypeRequest) => Type.TPowerQueryType | undefined;
export declare type TExternalInvocationTypeResolverFn = (request: ExternalInvocationTypeRequest) => Promise<Type.TPowerQueryType | undefined>;
export declare type TExternalValueTypeResolverFn = (request: ExternalValueTypeRequest) => Promise<Type.TPowerQueryType | undefined>;
export declare enum ExternalTypeRequestKind {
    Invocation = "Invocation",
    Value = "Value"
}
export interface IExternalType {
    readonly kind: ExternalTypeRequestKind;
    readonly identifierLiteral: string;
}
export interface ExternalValueTypeRequest extends IExternalType {
    readonly kind: ExternalTypeRequestKind.Value;
}
export interface ExternalInvocationTypeRequest extends IExternalType {
    readonly kind: ExternalTypeRequestKind.Invocation;
    readonly args: ReadonlyArray<Type.TPowerQueryType>;
}
export declare function noOpExternalTypeResolver(_request: TExternalTypeRequest): undefined;
