"use strict";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
Object.defineProperty(exports, "__esModule", { value: true });
exports.invocationTypeRequest = exports.valueTypeRequest = exports.composeExternalTypeResolvers = void 0;
const _1 = require(".");
function composeExternalTypeResolvers(...resolverFns) {
    return (request) => {
        for (const resolverFn of resolverFns) {
            const resolvedType = resolverFn(request);
            if (resolvedType !== undefined) {
                return resolvedType;
            }
        }
        return undefined;
    };
}
exports.composeExternalTypeResolvers = composeExternalTypeResolvers;
function valueTypeRequest(identifierLiteral) {
    return {
        kind: _1.ExternalType.ExternalTypeRequestKind.Value,
        identifierLiteral,
    };
}
exports.valueTypeRequest = valueTypeRequest;
function invocationTypeRequest(identifierLiteral, args) {
    return {
        kind: _1.ExternalType.ExternalTypeRequestKind.Invocation,
        identifierLiteral,
        args,
    };
}
exports.invocationTypeRequest = invocationTypeRequest;
//# sourceMappingURL=externalTypeUtils.js.map