import { Ast } from "@microsoft/powerquery-parser/lib/powerquery-parser/language";
import type { Position } from "vscode-languageserver-types";
import { TXorNode } from "@microsoft/powerquery-parser/lib/powerquery-parser/parser";
export declare type TActiveNode = ActiveNode | OutOfBoundPosition;
export interface IActiveNode {
    readonly kind: ActiveNodeKind;
    readonly position: Position;
}
export interface ActiveNode extends IActiveNode {
    readonly kind: ActiveNodeKind.ActiveNode;
    readonly leafKind: ActiveNodeLeafKind;
    readonly ancestry: ReadonlyArray<TXorNode>;
    readonly exclusiveIdentifierUnderPosition: TActiveLeafIdentifier | undefined;
    readonly inclusiveIdentifierUnderPosition: TActiveLeafIdentifier | undefined;
    readonly isInKey: boolean;
}
export interface OutOfBoundPosition extends IActiveNode {
    readonly kind: ActiveNodeKind.OutOfBoundPosition;
}
export declare type TActiveLeafIdentifier = ActiveLeafIdentifierExpression | ActiveLeafIdentifier;
export interface IActiveLeafIdentifier<T extends Ast.GeneralizedIdentifier | Ast.Identifier | Ast.IdentifierExpression> {
    readonly node: T;
    readonly normalizedLiteral: string;
    readonly normalizedRecursiveLiteral: string | undefined;
}
export interface ActiveLeafIdentifierExpression extends IActiveLeafIdentifier<Ast.IdentifierExpression> {
    readonly node: Ast.IdentifierExpression;
}
export interface ActiveLeafIdentifier extends IActiveLeafIdentifier<Ast.GeneralizedIdentifier | Ast.Identifier> {
    readonly node: Ast.GeneralizedIdentifier | Ast.Identifier;
    readonly normalizedRecursiveLiteral: undefined;
    readonly isRecursive: false;
}
export declare enum ActiveNodeLeafKind {
    IsBeforePosition = "IsBeforePosition",
    IsInAst = "IsInAst",
    IsAfterPosition = "IsAfterPosition",
    ContextNode = "Context"
}
export declare enum ActiveNodeKind {
    ActiveNode = "ActiveNode",
    OutOfBoundPosition = "OutOfBoundPosition"
}
