"use strict";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
Object.defineProperty(exports, "__esModule", { value: true });
exports.autocompleteKeywordIdentifierPairedExpression = void 0;
const parser_1 = require("@microsoft/powerquery-parser/lib/powerquery-parser/parser");
const language_1 = require("@microsoft/powerquery-parser/lib/powerquery-parser/language");
const __1 = require("../../..");
function autocompleteKeywordIdentifierPairedExpression(state) {
    const childAttributeIndex = state.child.node.attributeIndex;
    // `section; s|`
    // `section; [] |`
    if (childAttributeIndex === 0 &&
        parser_1.AncestryUtils.nthChecked(state.activeNode.ancestry, state.ancestryIndex + 1, language_1.Ast.NodeKind.SectionMember)) {
        return [language_1.Keyword.KeywordKind.Shared];
    }
    else if (childAttributeIndex !== 2) {
        return [];
    }
    const leaf = parser_1.NodeIdMapUtils.leftMostLeaf(state.nodeIdMapCollection, state.child.node.id);
    // `x = |`
    // `x = |1`
    if (leaf === undefined || __1.PositionUtils.isBeforeAst(state.activeNode.position, leaf, false)) {
        return language_1.Keyword.ExpressionKeywordKinds;
    }
    else {
        return undefined;
    }
}
exports.autocompleteKeywordIdentifierPairedExpression = autocompleteKeywordIdentifierPairedExpression;
//# sourceMappingURL=autocompleteKeywordIdentifierPairedExpression.js.map