"use strict";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
Object.defineProperty(exports, "__esModule", { value: true });
exports.autocompleteKeywordTrailingText = void 0;
const PQP = require("@microsoft/powerquery-parser");
const powerquery_parser_1 = require("@microsoft/powerquery-parser");
const language_1 = require("@microsoft/powerquery-parser/lib/powerquery-parser/language");
function autocompleteKeywordTrailingText(inspected, trailingToken, allowedKeywords) {
    if (trailingToken.isPositionEitherInOrOnToken === false) {
        return inspected;
    }
    powerquery_parser_1.Assert.isTrue(trailingToken.data.length > 0, "trailingToken.data.length > 0");
    const token = trailingToken;
    allowedKeywords = allowedKeywords !== null && allowedKeywords !== void 0 ? allowedKeywords : PartialConjunctionKeywordAutocompleteMap.get(token.data[0]);
    if (allowedKeywords !== undefined) {
        return PQP.ArrayUtils.concatUnique(inspected, allowedKeywords.filter((keyword) => keyword.startsWith(token.data)));
    }
    else {
        return inspected;
    }
}
exports.autocompleteKeywordTrailingText = autocompleteKeywordTrailingText;
// Used with parseError to see if a user could be typing a conjunctive keyword such as 'or'. Eg.
// 'Details[UserName] <> "" o|'
const PartialConjunctionKeywordAutocompleteMap = new Map([
    ["a", [language_1.Keyword.KeywordKind.And, language_1.Keyword.KeywordKind.As]],
    ["i", [language_1.Keyword.KeywordKind.Is]],
    ["m", [language_1.Keyword.KeywordKind.Meta]],
    ["o", [language_1.Keyword.KeywordKind.Or]],
]);
//# sourceMappingURL=autocompleteKeywordTrailingText.js.map