import * as PQP from "@microsoft/powerquery-parser";
import { Range } from "vscode-languageserver-types";
import { TXorNode } from "@microsoft/powerquery-parser/lib/powerquery-parser/parser";
import { Type } from "@microsoft/powerquery-parser/lib/powerquery-parser/language";
import { AutocompleteItem } from "./autocompleteItem";
export declare type TriedAutocompleteFieldAccess = PQP.Result<AutocompleteFieldAccess | undefined, PQP.CommonError.CommonError>;
export declare type TriedAutocompleteKeyword = PQP.Result<ReadonlyArray<AutocompleteItem>, PQP.CommonError.CommonError>;
export declare type TriedAutocompleteLanguageConstant = PQP.Result<ReadonlyArray<AutocompleteItem>, PQP.CommonError.CommonError>;
export declare type TriedAutocompletePrimitiveType = PQP.Result<ReadonlyArray<AutocompleteItem>, PQP.CommonError.CommonError>;
export interface Autocomplete {
    readonly triedFieldAccess: TriedAutocompleteFieldAccess;
    readonly triedKeyword: TriedAutocompleteKeyword;
    readonly triedLanguageConstant: TriedAutocompleteLanguageConstant;
    readonly triedPrimitiveType: TriedAutocompletePrimitiveType;
}
export interface AutocompleteFieldAccess {
    readonly field: TXorNode;
    readonly fieldType: Type.TPowerQueryType;
    readonly inspectedFieldAccess: InspectedFieldAccess;
    readonly autocompleteItems: ReadonlyArray<AutocompleteItem>;
}
export interface InspectedFieldAccess {
    readonly fieldNames: ReadonlyArray<string>;
    readonly isAutocompleteAllowed: boolean;
    readonly textEditRange: Range | undefined;
    readonly textUnderPosition: string | undefined;
}
