"use strict";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
Object.defineProperty(exports, "__esModule", { value: true });
exports.createTrailingToken = void 0;
const __1 = require("../..");
function createTrailingToken(position, parseErrorToken) {
    const tokenStartComparison = __1.PositionUtils.compareTokenPosition(position, parseErrorToken.positionStart);
    const tokenEndComparison = __1.PositionUtils.compareTokenPosition(position, parseErrorToken.positionEnd);
    return Object.assign(Object.assign({}, parseErrorToken), { tokenStartComparison,
        tokenEndComparison, 
        // This is another way of saying:
        //  - startComparison is OnToken or RightOfToken
        //  - endComparison is OnToken or LeftOfToken
        isPositionEitherInOrOnToken: tokenStartComparison !== __1.TokenPositionComparison.LeftOfToken &&
            tokenEndComparison !== __1.TokenPositionComparison.RightOfToken });
}
exports.createTrailingToken = createTrailingToken;
//# sourceMappingURL=trailingTokenUtils.js.map