import { EachExpression, FunctionExpression, LetExpression, RecordExpression, RecordLiteral, SectionMember } from "@microsoft/powerquery-parser/lib/powerquery-parser/language/ast/ast";
import { EachScopeItem, LetVariableScopeItem, NodeScope, ParameterScopeItem, RecordFieldScopeItem, SectionMemberScopeItem, TScopeItem, UndefinedScopeItem } from "./scope";
import { Ast } from "@microsoft/powerquery-parser/lib/powerquery-parser/language";
import { NodeIdMap } from "@microsoft/powerquery-parser/lib/powerquery-parser/parser";
export * from "./scope";
export * from "./scopeInspection";
export declare function assertGetScopeItemChecked<T extends TScopeItem>(nodeScope: NodeScope, key: string, kind: T["kind"]): T;
export declare function isEach(value: TScopeItem | undefined): value is EachScopeItem;
export declare function isLetVariable(value: TScopeItem | undefined): value is LetVariableScopeItem;
export declare function isParameter(value: TScopeItem | undefined): value is ParameterScopeItem;
export declare function isRecordField(value: TScopeItem | undefined): value is RecordFieldScopeItem;
export declare function isSectionMember(value: TScopeItem | undefined): value is SectionMemberScopeItem;
export declare function isUndefined(value: TScopeItem | undefined): value is UndefinedScopeItem;
export declare function getScopeItemChecked<T extends TScopeItem>(nodeScope: NodeScope, key: string, kind: T["kind"]): T | undefined;
export declare function findScopeItemByLiteral(nodeScope: NodeScope | undefined, literalString: string): TScopeItem | undefined;
export declare function scopeCreatorIdentifier(scopeItem: TScopeItem | undefined): Ast.Identifier | Ast.GeneralizedIdentifier | undefined;
export declare function findDirectUpperScopeExpression(nodeIdMapCollection: NodeIdMap.Collection, nodeId: number): EachExpression | FunctionExpression | LetExpression | RecordExpression | RecordLiteral | SectionMember | undefined;
