"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.findDirectUpperScopeExpression = exports.scopeCreatorIdentifier = exports.findScopeItemByLiteral = exports.getScopeItemChecked = exports.isUndefined = exports.isSectionMember = exports.isRecordField = exports.isParameter = exports.isLetVariable = exports.isEach = exports.assertGetScopeItemChecked = void 0;
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
const PQP = require("@microsoft/powerquery-parser");
const scope_1 = require("./scope");
const language_1 = require("@microsoft/powerquery-parser/lib/powerquery-parser/language");
__exportStar(require("./scope"), exports);
__exportStar(require("./scopeInspection"), exports);
function assertGetScopeItemChecked(nodeScope, key, kind) {
    const scopeItem = getScopeItemChecked(nodeScope, key, kind);
    if (scopeItem === undefined) {
        throw new PQP.CommonError.InvariantError(`expected a '${kind}' scope item with key '${key}'`);
    }
    return scopeItem;
}
exports.assertGetScopeItemChecked = assertGetScopeItemChecked;
function isEach(value) {
    return (value === null || value === void 0 ? void 0 : value.kind) === scope_1.ScopeItemKind.Each;
}
exports.isEach = isEach;
function isLetVariable(value) {
    return (value === null || value === void 0 ? void 0 : value.kind) === scope_1.ScopeItemKind.LetVariable;
}
exports.isLetVariable = isLetVariable;
function isParameter(value) {
    return (value === null || value === void 0 ? void 0 : value.kind) === scope_1.ScopeItemKind.Parameter;
}
exports.isParameter = isParameter;
function isRecordField(value) {
    return (value === null || value === void 0 ? void 0 : value.kind) === scope_1.ScopeItemKind.RecordField;
}
exports.isRecordField = isRecordField;
function isSectionMember(value) {
    return (value === null || value === void 0 ? void 0 : value.kind) === scope_1.ScopeItemKind.SectionMember;
}
exports.isSectionMember = isSectionMember;
function isUndefined(value) {
    return (value === null || value === void 0 ? void 0 : value.kind) === scope_1.ScopeItemKind.Undefined;
}
exports.isUndefined = isUndefined;
function getScopeItemChecked(nodeScope, key, kind) {
    const scopeItem = nodeScope.get(key);
    if ((scopeItem === null || scopeItem === void 0 ? void 0 : scopeItem.kind) !== kind) {
        return undefined;
    }
    return scopeItem;
}
exports.getScopeItemChecked = getScopeItemChecked;
function findScopeItemByLiteral(nodeScope, literalString) {
    return nodeScope === null || nodeScope === void 0 ? void 0 : nodeScope.get(literalString);
}
exports.findScopeItemByLiteral = findScopeItemByLiteral;
function scopeCreatorIdentifier(scopeItem) {
    if (!scopeItem) {
        return undefined;
    }
    switch (scopeItem.kind) {
        case scope_1.ScopeItemKind.Each:
        case scope_1.ScopeItemKind.Undefined:
            return undefined;
        case scope_1.ScopeItemKind.LetVariable:
        case scope_1.ScopeItemKind.RecordField:
        case scope_1.ScopeItemKind.SectionMember:
            return scopeItem.key;
        case scope_1.ScopeItemKind.Parameter:
            return scopeItem.name;
        default:
            throw PQP.Assert.isNever(scopeItem);
    }
}
exports.scopeCreatorIdentifier = scopeCreatorIdentifier;
function findDirectUpperScopeExpression(nodeIdMapCollection, nodeId) {
    const astNodeById = nodeIdMapCollection.astNodeById;
    const parentIdById = nodeIdMapCollection.parentIdById;
    let currentNode = astNodeById.get(nodeId);
    while (currentNode &&
        currentNode.kind !== language_1.Ast.NodeKind.EachExpression &&
        currentNode.kind !== language_1.Ast.NodeKind.FunctionExpression &&
        currentNode.kind !== language_1.Ast.NodeKind.LetExpression &&
        currentNode.kind !== language_1.Ast.NodeKind.RecordExpression &&
        currentNode.kind !== language_1.Ast.NodeKind.RecordLiteral &&
        currentNode.kind !== language_1.Ast.NodeKind.SectionMember) {
        const currentParentId = parentIdById.get(currentNode.id) || -1;
        currentNode = astNodeById.get(currentParentId);
    }
    return currentNode;
}
exports.findDirectUpperScopeExpression = findDirectUpperScopeExpression;
//# sourceMappingURL=scopeUtils.js.map