import * as PQP from "@microsoft/powerquery-parser";
import { NodeIdMap } from "@microsoft/powerquery-parser/lib/powerquery-parser/parser";
import { Ast } from "@microsoft/powerquery-parser/lib/powerquery-parser/language";
import type { Position } from "vscode-languageserver-types";
import { TActiveNode } from "./activeNode";
import { Inspection } from "..";
import { TriedExpectedType } from "./expectedType";
import { TriedNodeScope } from "./scope";
import { TypeCache } from "./typeCache";
import { Inspected } from "./commonTypes";
import { InspectionSettings } from "../inspectionSettings";
export declare class InspectionInstance implements Inspected {
    readonly settings: InspectionSettings;
    readonly nodeIdMapCollection: NodeIdMap.Collection;
    readonly activeNode: TActiveNode;
    readonly autocomplete: Inspection.Autocomplete;
    readonly triedCurrentInvokeExpression: Promise<Inspection.TriedCurrentInvokeExpression>;
    readonly triedNodeScope: Promise<Inspection.TriedNodeScope>;
    readonly triedScopeType: Promise<Inspection.TriedScopeType>;
    readonly triedExpectedType: TriedExpectedType;
    readonly typeCache: TypeCache;
    readonly parseState: PQP.Parser.ParseState;
    constructor(settings: InspectionSettings, nodeIdMapCollection: NodeIdMap.Collection, activeNode: TActiveNode, autocomplete: Inspection.Autocomplete, triedCurrentInvokeExpression: Promise<Inspection.TriedCurrentInvokeExpression>, triedNodeScope: Promise<Inspection.TriedNodeScope>, triedScopeType: Promise<Inspection.TriedScopeType>, triedExpectedType: TriedExpectedType, typeCache: TypeCache, parseState: PQP.Parser.ParseState);
    tryNodeScope(id: number): Promise<TriedNodeScope>;
    collectAllIdentifiersBeneath(valueCreator: Ast.Identifier | Ast.GeneralizedIdentifier): Promise<Array<Ast.Identifier | Ast.GeneralizedIdentifier>>;
}
export declare function inspect(settings: InspectionSettings, parseState: PQP.Parser.ParseState, parseError: PQP.Parser.ParseError.ParseError | undefined, position: Position, typeCache?: TypeCache): Promise<Inspected>;
export declare function tryInspect(settings: InspectionSettings, text: string, position: Position, typeCache?: TypeCache): Promise<PQP.Result<Promise<Inspected>, PQP.Lexer.LexError.TLexError | PQP.Parser.ParseError.TParseError>>;
