import * as PQP from "@microsoft/powerquery-parser";
import { Type } from "@microsoft/powerquery-parser/lib/powerquery-parser/language";
import { NodeIdMap, TXorNode } from "@microsoft/powerquery-parser/lib/powerquery-parser/parser";
import { Inspection } from "../../..";
import { NodeScope, ParameterScopeItem, ScopeById, TScopeItem } from "../../scope";
import { InspectionSettings } from "../../../inspectionSettings";
import { TypeById } from "../../typeCache";
export interface InspectTypeState extends PQP.CommonSettings, Omit<InspectionSettings, keyof PQP.Lexer.LexSettings | keyof PQP.Parser.ParseSettings> {
    readonly typeById: TypeById;
    readonly nodeIdMapCollection: NodeIdMap.Collection;
    readonly scopeById: ScopeById;
}
export declare function allForAnyUnion(anyUnion: Type.AnyUnion, predicate: (type: Type.TPowerQueryType) => boolean): boolean;
export declare function assertGetOrCreateNodeScope(state: InspectTypeState, nodeId: number, correlationId: number | undefined): Promise<NodeScope>;
export declare function getOrCreateScope(state: InspectTypeState, nodeId: number, correlationId: number | undefined): Promise<Inspection.TriedNodeScope>;
export declare function getOrCreateScopeItemType(state: InspectTypeState, scopeItem: TScopeItem): Promise<Type.TPowerQueryType>;
export declare function inspectScopeItem(state: InspectTypeState, scopeItem: TScopeItem, correlationId: number | undefined): Promise<Type.TPowerQueryType>;
export declare function inspectTypeFromChildAttributeIndex(state: InspectTypeState, parentXorNode: TXorNode, attributeIndex: number, correlationId: number | undefined): Promise<Type.TPowerQueryType>;
export declare function inspectXor(state: InspectTypeState, xorNode: TXorNode, correlationId: number | undefined): Promise<Type.TPowerQueryType>;
export declare function dereferencedIdentifierType(state: InspectTypeState, xorNode: TXorNode, correlationId: number | undefined): Promise<Type.TPowerQueryType | undefined>;
export declare function createParameterType(parameter: ParameterScopeItem): Type.TPrimitiveType;
