"use strict";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.inspectTypeIdentifierExpression = void 0;
const language_1 = require("@microsoft/powerquery-parser/lib/powerquery-parser/language");
const trace_1 = require("@microsoft/powerquery-parser/lib/powerquery-parser/common/trace");
const parser_1 = require("@microsoft/powerquery-parser/lib/powerquery-parser/parser");
const common_1 = require("./common");
const __1 = require("../../..");
function inspectTypeIdentifierExpression(state, xorNode, correlationId) {
    var _a;
    return __awaiter(this, void 0, void 0, function* () {
        const trace = state.traceManager.entry(__1.InspectionTraceConstant.InspectType, inspectTypeIdentifierExpression.name, correlationId, __1.TraceUtils.xorNodeDetails(xorNode));
        (_a = state.cancellationToken) === null || _a === void 0 ? void 0 : _a.throwIfCancelled();
        parser_1.XorNodeUtils.assertIsNodeKind(xorNode, language_1.Ast.NodeKind.IdentifierExpression);
        let result;
        if (parser_1.XorNodeUtils.isContext(xorNode)) {
            result = language_1.Type.UnknownInstance;
        }
        else {
            const dereferencedType = yield (0, common_1.dereferencedIdentifierType)(state, xorNode, trace.id);
            result = dereferencedType !== null && dereferencedType !== void 0 ? dereferencedType : language_1.Type.UnknownInstance;
        }
        trace.exit({ [trace_1.TraceConstant.Result]: __1.TraceUtils.typeDetails(result) });
        return result;
    });
}
exports.inspectTypeIdentifierExpression = inspectTypeIdentifierExpression;
//# sourceMappingURL=inspectTypeIdentifierExpression.js.map