"use strict";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
Object.defineProperty(exports, "__esModule", { value: true });
exports.inspectTypePrimitiveType = void 0;
const language_1 = require("@microsoft/powerquery-parser/lib/powerquery-parser/language");
const trace_1 = require("@microsoft/powerquery-parser/lib/powerquery-parser/common/trace");
const parser_1 = require("@microsoft/powerquery-parser/lib/powerquery-parser/parser");
const __1 = require("../../..");
function inspectTypePrimitiveType(state, xorNode, correlationId) {
    const trace = state.traceManager.entry(__1.InspectionTraceConstant.InspectType, inspectTypePrimitiveType.name, correlationId, __1.TraceUtils.xorNodeDetails(xorNode));
    parser_1.XorNodeUtils.assertIsNodeKind(xorNode, language_1.Ast.NodeKind.PrimitiveType);
    if (parser_1.XorNodeUtils.isContext(xorNode)) {
        trace.exit({ [trace_1.TraceConstant.Result]: __1.TraceUtils.typeDetails(language_1.Type.UnknownInstance) });
        return language_1.Type.UnknownInstance;
    }
    const kind = language_1.TypeUtils.typeKindFromPrimitiveTypeConstantKind(xorNode.node.primitiveTypeKind);
    const result = {
        kind,
        extendedKind: undefined,
        isNullable: false,
    };
    trace.exit({ [trace_1.TraceConstant.Result]: __1.TraceUtils.typeDetails(result) });
    return result;
}
exports.inspectTypePrimitiveType = inspectTypePrimitiveType;
//# sourceMappingURL=inspectTypePrimitiveType.js.map