import * as PQP from "@microsoft/powerquery-parser";
import { Ast, Type } from "@microsoft/powerquery-parser/lib/powerquery-parser/language";
import { DocumentSymbol, SymbolKind } from "vscode-languageserver-types";
import { Inspection } from ".";
import { InspectionSettings } from "./inspectionSettings";
import { AutocompleteItemProviderContext } from "./providers/commonTypes";
export declare function inspectionSettings(settings: PQP.Settings, overrides?: Partial<InspectionSettings>): InspectionSettings;
export declare function getAutocompleteItemsFromScope(context: AutocompleteItemProviderContext): ReadonlyArray<Inspection.AutocompleteItem>;
export declare function getIdentifierType(inspected: Inspection.Inspected, identifier: string): Promise<Type.TPowerQueryType | undefined>;
export declare function getScopeItemKindText(scopeItemKind: Inspection.ScopeItemKind): string;
export declare function getSymbolKindFromLiteralExpression(node: Ast.LiteralExpression): SymbolKind;
export declare function getSymbolKindFromNode(node: Ast.TNode): SymbolKind;
export declare function getSymbolsForLetExpression(expressionNode: Ast.LetExpression): ReadonlyArray<DocumentSymbol>;
export declare function getSymbolsForRecord(recordNode: Ast.RecordExpression | Ast.RecordLiteral): ReadonlyArray<DocumentSymbol>;
export declare function getSymbolsForSection(sectionNode: Ast.Section): ReadonlyArray<DocumentSymbol>;
export declare function getSymbolForIdentifierPairedExpression(identifierPairedExpressionNode: Ast.IdentifierPairedExpression): DocumentSymbol;
