"use strict";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
Object.defineProperty(exports, "__esModule", { value: true });
exports.symbolKindToCompletionItemKind = void 0;
const vscode_languageserver_types_1 = require("vscode-languageserver-types");
function symbolKindToCompletionItemKind(symbolKind) {
    switch (symbolKind) {
        case vscode_languageserver_types_1.SymbolKind.Array:
        case vscode_languageserver_types_1.SymbolKind.Boolean:
        case vscode_languageserver_types_1.SymbolKind.Number:
        case vscode_languageserver_types_1.SymbolKind.Null:
        case vscode_languageserver_types_1.SymbolKind.String:
            return vscode_languageserver_types_1.CompletionItemKind.Value;
        case vscode_languageserver_types_1.SymbolKind.Module:
            return vscode_languageserver_types_1.CompletionItemKind.Module;
        case vscode_languageserver_types_1.SymbolKind.Field:
            return vscode_languageserver_types_1.CompletionItemKind.Field;
        case vscode_languageserver_types_1.SymbolKind.Constructor:
            return vscode_languageserver_types_1.CompletionItemKind.Constructor;
        case vscode_languageserver_types_1.SymbolKind.Enum:
            return vscode_languageserver_types_1.CompletionItemKind.Enum;
        case vscode_languageserver_types_1.SymbolKind.EnumMember:
            return vscode_languageserver_types_1.CompletionItemKind.EnumMember;
        case vscode_languageserver_types_1.SymbolKind.Function:
            return vscode_languageserver_types_1.CompletionItemKind.Function;
        case vscode_languageserver_types_1.SymbolKind.Variable:
            return vscode_languageserver_types_1.CompletionItemKind.Variable;
        case vscode_languageserver_types_1.SymbolKind.Constant:
            return vscode_languageserver_types_1.CompletionItemKind.Constant;
        case vscode_languageserver_types_1.SymbolKind.Struct:
            return vscode_languageserver_types_1.CompletionItemKind.Struct;
        case vscode_languageserver_types_1.SymbolKind.TypeParameter:
            return vscode_languageserver_types_1.CompletionItemKind.TypeParameter;
        default:
            return undefined;
    }
}
exports.symbolKindToCompletionItemKind = symbolKindToCompletionItemKind;
//# sourceMappingURL=languageServiceUtils.js.map