import { CompletionItemKind, ParameterInformation, SignatureInformation } from "vscode-languageserver-types";
import { Type } from "@microsoft/powerquery-parser/lib/powerquery-parser/language";
import { LibraryConstant, LibraryDefinitions, LibraryFunction, LibraryParameter, LibraryType, TLibraryDefinition } from "./library";
import { ExternalType } from "../externalType";
export declare function assertAsConstant(definition: TLibraryDefinition | undefined): LibraryConstant;
export declare function assertAsFunction(definition: TLibraryDefinition | undefined): LibraryFunction;
export declare function assertAsType(definition: TLibraryDefinition | undefined): LibraryType;
export declare function assertIsConstant(definition: TLibraryDefinition | undefined): asserts definition is LibraryConstant;
export declare function assertIsFunction(definition: TLibraryDefinition | undefined): asserts definition is LibraryFunction;
export declare function assertIsType(definition: TLibraryDefinition | undefined): asserts definition is LibraryType;
export declare function constantDefinition(label: string, description: string, asType: Type.TPowerQueryType, completionItemKind: CompletionItemKind): LibraryConstant;
export declare function externalTypeResolver(libraryDefinitions: LibraryDefinitions): ExternalType.TExternalTypeResolverFn;
export declare function functionDefinition(label: string, description: string, asType: Type.TPowerQueryType, completionItemKind: CompletionItemKind, parameters: ReadonlyArray<LibraryParameter>): LibraryFunction;
export declare function getDefinition(libraryDefinitions: LibraryDefinitions, identifierLiteral: string): TLibraryDefinition | undefined;
export declare function getKeys(libraryDefinitions: LibraryDefinitions): ReadonlyArray<string>;
export declare function hasDefinition(libraryDefinitions: LibraryDefinitions, key: string): boolean;
export declare function isConstant(definition: TLibraryDefinition | undefined): definition is LibraryConstant;
export declare function isFunction(definition: TLibraryDefinition | undefined): definition is LibraryFunction;
export declare function isType(definition: TLibraryDefinition | undefined): definition is LibraryType;
export declare function signatureInformation(libraryFunctionSignature: LibraryFunction): SignatureInformation;
export declare function parameterInformation(libraryParameter: LibraryParameter): ParameterInformation;
