"use strict";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
Object.defineProperty(exports, "__esModule", { value: true });
exports.nameOf = exports.parameterInformation = exports.signatureInformation = exports.hasDefinition = exports.getDefinitionKeys = exports.getDefinition = void 0;
const powerquery_parser_1 = require("@microsoft/powerquery-parser");
const library_1 = require("./library");
const _1 = require(".");
function getDefinition(library, identifierLiteral) {
    return _1.LibraryDefinitionUtils.getDefinition(library.libraryDefinitions, identifierLiteral);
}
exports.getDefinition = getDefinition;
function getDefinitionKeys(library) {
    return _1.LibraryDefinitionUtils.getKeys(library.libraryDefinitions);
}
exports.getDefinitionKeys = getDefinitionKeys;
function hasDefinition(library, key) {
    return _1.LibraryDefinitionUtils.hasDefinition(library.libraryDefinitions, key);
}
exports.hasDefinition = hasDefinition;
function signatureInformation(libraryFunctionSignature) {
    return {
        label: libraryFunctionSignature.label,
        documentation: libraryFunctionSignature.description,
        parameters: libraryFunctionSignature.parameters.map(parameterInformation),
    };
}
exports.signatureInformation = signatureInformation;
function parameterInformation(libraryParameter) {
    return {
        label: libraryParameter.label,
        documentation: undefined,
    };
}
exports.parameterInformation = parameterInformation;
function nameOf(kind) {
    switch (kind) {
        case library_1.LibraryDefinitionKind.Function:
            return "library function";
        case library_1.LibraryDefinitionKind.Constant:
            return "library constant";
        case library_1.LibraryDefinitionKind.Type:
            return "library type";
        default:
            throw powerquery_parser_1.Assert.isNever(kind);
    }
}
exports.nameOf = nameOf;
//# sourceMappingURL=libraryUtils.js.map