"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Localization = void 0;
const powerquery_parser_1 = require("@microsoft/powerquery-parser");
exports.Localization = {
    error_validation_duplicate_identifier: (templates, identifier) => powerquery_parser_1.StringUtils.assertGetFormatted(templates.error_validation_duplicate_identifier, new Map([["identifier", identifier]])),
    error_validation_invokeExpression_missingMandatory: (templates, functionName, argName) => {
        if (functionName) {
            return powerquery_parser_1.StringUtils.assertGetFormatted(templates.error_validation_invokeExpression_missingMandatory_named, new Map([
                ["funcName", functionName],
                ["argName", argName],
            ]));
        }
        else {
            return powerquery_parser_1.StringUtils.assertGetFormatted(templates.error_validation_invokeExpression_missingMandatory_unnamed, new Map([["argName", argName]]));
        }
    },
    error_validation_invokeExpression_numArgs: (templates, numMin, numMax, numGiven) => powerquery_parser_1.StringUtils.assertGetFormatted(templates.error_validation_invokeExpression_numArgs, new Map([
        ["numMin", numMin.toString()],
        ["numMax", numMax.toString()],
        ["numGiven", numGiven.toString()],
    ])),
    error_validation_invokeExpression_typeMismatch: (templates, functionName, argName, expected, actual) => {
        if (functionName) {
            return powerquery_parser_1.StringUtils.assertGetFormatted(templates.error_validation_invokeExpression_typeMismatch_named, new Map([
                ["funcName", functionName],
                ["argName", argName],
                ["expected", expected],
                ["actual", actual],
            ]));
        }
        else {
            return powerquery_parser_1.StringUtils.assertGetFormatted(templates.error_validation_invokeExpression_typeMismatch_unnamed, new Map([
                ["argName", argName],
                ["expected", expected],
                ["actual", actual],
            ]));
        }
    },
    error_validation_unknownIdentifier: (templates, identifier, suggestion) => {
        if (suggestion === undefined) {
            return powerquery_parser_1.StringUtils.assertGetFormatted(templates.error_validation_unknownIdentifier_noSuggestion, new Map([["identifier", identifier]]));
        }
        else {
            return powerquery_parser_1.StringUtils.assertGetFormatted(templates.error_validation_unknownIdentifier_suggestion, new Map([
                ["identifier", identifier],
                ["suggestion", suggestion],
            ]));
        }
    },
};
//# sourceMappingURL=localization.js.map