import * as PQP from "@microsoft/powerquery-parser";
import { NodeIdMap, TXorNode } from "@microsoft/powerquery-parser/lib/powerquery-parser/parser";
import type { Position, Range } from "vscode-languageserver-types";
import { Ast } from "@microsoft/powerquery-parser/lib/powerquery-parser/language";
import { TokenPositionComparison } from "./tokenPositionComparison";
export declare function compareTokenPosition(position: Position, tokenPosition: PQP.Language.Token.TokenPosition): TokenPositionComparison;
export declare function positionFromTokenPosition(tokenPosition: PQP.Language.Token.TokenPosition): Position;
export declare function rangeFromXorNode(nodeIdMapCollection: NodeIdMap.Collection, xorNode: TXorNode): Promise<Range | undefined>;
export declare function rangeFromToken(token: PQP.Language.Token.Token): Range;
export declare function rangeFromTokenPositions(startTokenPosition: PQP.Language.Token.TokenPosition | undefined, endTokenPosition: PQP.Language.Token.TokenPosition | undefined): Range | undefined;
export declare function rangeFromTokenRange(tokenRange: PQP.Language.Token.TokenRange): Range;
export declare function isBeforeXor(position: Position, xorNode: TXorNode, isBoundIncluded: boolean): boolean;
export declare function isInXor(nodeIdMapCollection: NodeIdMap.Collection, position: Position, xorNode: TXorNode, isLowerBoundIncluded: boolean, isUpperBoundIncluded: boolean): boolean;
export declare function isOnXorStart(position: Position, xorNode: TXorNode): boolean;
export declare function isOnXorEnd(nodeIdMapCollection: NodeIdMap.Collection, position: Position, xorNode: TXorNode): Promise<boolean>;
export declare function isAfterXor(nodeIdMapCollection: NodeIdMap.Collection, position: Position, xorNode: TXorNode, isBoundIncluded: boolean): Promise<boolean>;
export declare function isBeforeContext(position: Position, contextNode: PQP.Parser.ParseContext.TNode, isBoundIncluded: boolean): boolean;
export declare function isInContext(nodeIdMapCollection: NodeIdMap.Collection, position: Position, contextNode: PQP.Parser.ParseContext.TNode, isLowerBoundIncluded: boolean, isHigherBoundIncluded: boolean): boolean;
export declare function isOnContextStart(position: Position, contextNode: PQP.Parser.ParseContext.TNode): boolean;
export declare function isOnContextEnd(nodeIdMapCollection: NodeIdMap.Collection, position: Position, contextNode: PQP.Parser.ParseContext.TNode): Promise<boolean>;
export declare function isAfterContext(nodeIdMapCollection: NodeIdMap.Collection, position: Position, contextNode: PQP.Parser.ParseContext.TNode, isBoundIncluded: boolean): Promise<boolean>;
export declare function isBeforeAst(position: Position, astNode: Ast.TNode, isBoundIncluded: boolean): boolean;
export declare function isInAst(position: Position, astNode: Ast.TNode, isLowerBoundIncluded: boolean, isHigherBoundIncluded: boolean): boolean;
export declare function isOnAstStart(position: Position, astNode: Ast.TNode): boolean;
export declare function isOnAstEnd(position: Position, astNode: Ast.TNode): boolean;
export declare function isAfterAst(position: Position, astNode: Ast.TNode, isBoundIncluded: boolean): boolean;
export declare function isOnTokenStart(position: Position, token: PQP.Language.Token.Token): boolean;
export declare function isOnTokenEnd(position: Position, token: PQP.Language.Token.Token): boolean;
export declare function isInToken(position: Position, token: PQP.Language.Token.Token, isLowerBoundIncluded: boolean, isHigherBoundIncluded: boolean): boolean;
export declare function isBeforeTokenPosition(position: Position, tokenPosition: PQP.Language.Token.TokenPosition, isBoundIncluded: boolean): boolean;
export declare function isOnTokenPosition(position: Position, tokenPosition: PQP.Language.Token.TokenPosition): boolean;
export declare function isAfterTokenPosition(position: Position, tokenPosition: PQP.Language.Token.TokenPosition, isBoundIncluded: boolean): boolean;
