import { CommonError, Result } from "@microsoft/powerquery-parser";
import { Hover, SignatureHelp, SignatureInformation } from "vscode-languageserver-types";
import { AutocompleteItemProviderContext, HoverProviderContext, ILibraryProvider, SignatureProviderContext } from "./commonTypes";
import { Library } from "../library";
import { Inspection } from "..";
export declare class LibraryProvider implements ILibraryProvider {
    protected readonly locale: string;
    readonly library: Library.ILibrary;
    protected readonly signatureInformationByLabel: Map<string, SignatureInformation>;
    constructor(library: Library.ILibrary, locale: string);
    getAutocompleteItems(context: AutocompleteItemProviderContext): Promise<Result<Inspection.AutocompleteItem[] | undefined, CommonError.CommonError>>;
    getHover(context: HoverProviderContext): Promise<Result<Hover | undefined, CommonError.CommonError>>;
    getSignatureHelp(context: SignatureProviderContext): Promise<Result<SignatureHelp | undefined, CommonError.CommonError>>;
    private static getDefinitionKindText;
    private getOrCreateSignatureInformation;
}
