import { CommonError, Result } from "@microsoft/powerquery-parser";
import { FoldingRange, Location } from "vscode-languageserver-types";
import { AutocompleteItemProviderContext, DefinitionProviderContext, HoverProviderContext, PartialSemanticToken, ProviderContext, SignatureProviderContext } from "./commonTypes";
import { IAutocompleteItemProvider, IDefinitionProvider, IFoldingRangeProvider, IHoverProvider, ISemanticTokenProvider, ISignatureHelpProvider } from "../providers";
import { ExternalType, Library } from "..";
import { Hover, SignatureHelp } from "../commonTypes";
import { AutocompleteItem } from "../inspection/autocomplete";
export declare class NullSymbolProvider implements IAutocompleteItemProvider, IDefinitionProvider, IFoldingRangeProvider, IHoverProvider, ISemanticTokenProvider, ISignatureHelpProvider {
    readonly externalTypeResolver: ExternalType.TExternalTypeResolverFn;
    readonly libraryDefinitions: Library.LibraryDefinitions;
    private static instance;
    static singleton(): NullSymbolProvider;
    getAutocompleteItems(_context: AutocompleteItemProviderContext): Promise<Result<AutocompleteItem[] | undefined, CommonError.CommonError>>;
    getDefinition(_context: DefinitionProviderContext): Promise<Result<Location[] | undefined, CommonError.CommonError>>;
    getFoldingRanges(_context: ProviderContext): Promise<Result<FoldingRange[], CommonError.CommonError>>;
    getHover(_context: HoverProviderContext): Promise<Result<Hover | undefined, CommonError.CommonError>>;
    getPartialSemanticTokens(_context: ProviderContext): Promise<Result<PartialSemanticToken[] | undefined, CommonError.CommonError>>;
    getSignatureHelp(_context: SignatureProviderContext): Promise<Result<SignatureHelp | undefined, CommonError.CommonError>>;
}
