"use strict";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NullSymbolProvider = void 0;
const powerquery_parser_1 = require("@microsoft/powerquery-parser");
const __1 = require("..");
class NullSymbolProvider {
    constructor() {
        this.externalTypeResolver = __1.ExternalType.noOpExternalTypeResolver;
        this.libraryDefinitions = {
            dynamicLibraryDefinitions: () => new Map(),
            staticLibraryDefinitions: new Map(),
        };
    }
    static singleton() {
        if (NullSymbolProvider.instance === undefined) {
            NullSymbolProvider.instance = new NullSymbolProvider();
        }
        return NullSymbolProvider.instance;
    }
    // eslint-disable-next-line require-await
    getAutocompleteItems(_context) {
        return __awaiter(this, void 0, void 0, function* () {
            return powerquery_parser_1.ResultUtils.ok(undefined);
        });
    }
    // eslint-disable-next-line require-await
    getDefinition(_context) {
        return __awaiter(this, void 0, void 0, function* () {
            return powerquery_parser_1.ResultUtils.ok(undefined);
        });
    }
    // eslint-disable-next-line require-await
    getFoldingRanges(_context) {
        return __awaiter(this, void 0, void 0, function* () {
            return powerquery_parser_1.ResultUtils.ok([]);
        });
    }
    // eslint-disable-next-line require-await
    getHover(_context) {
        return __awaiter(this, void 0, void 0, function* () {
            return powerquery_parser_1.ResultUtils.ok(undefined);
        });
    }
    // eslint-disable-next-line require-await
    getPartialSemanticTokens(_context) {
        return __awaiter(this, void 0, void 0, function* () {
            return powerquery_parser_1.ResultUtils.ok(undefined);
        });
    }
    // eslint-disable-next-line require-await
    getSignatureHelp(_context) {
        return __awaiter(this, void 0, void 0, function* () {
            return powerquery_parser_1.ResultUtils.ok(undefined);
        });
    }
}
exports.NullSymbolProvider = NullSymbolProvider;
//# sourceMappingURL=nullSymbolProvider.js.map